
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  ForestGreen
#property indicator_color2  DarkGoldenrod
#property indicator_color3  ForestGreen
#property indicator_color4  DarkGoldenrod
#property indicator_color5  ForestGreen
#property indicator_color6  DarkGoldenrod

#property indicator_minimum 0
#property indicator_maximum 5

//
//
//
//
//

extern string TimeFrame1            = "H1";
extern string TimeFrame2            = "M30";
extern string TimeFrame3            = "M15";
extern int    RsiPeriod             = 13;
extern int    RsiPrice              = PRICE_CLOSE;
extern double RsiLevelUp            = 51;
extern double RsiLevelDown          = 49;
extern bool   ColorsForSlope        = false;
extern string UniqueID              = "3 Time RSI 1";
extern int    LinesWidth            =  0;
extern color  LabelsColor           = Black;
extern int    LabelsHorizontalShift = 3;
extern double LabelsVerticalShift   = 1.5;

//
//
//
//
//

double rsi1u[];
double rsi1d[];
double rsi2u[];
double rsi2d[];
double rsi3u[];
double rsi3d[];


int    timeFrames[3];
bool   returnBars;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,rsi1u);
   SetIndexBuffer(1,rsi1d);
   SetIndexBuffer(2,rsi2u);
   SetIndexBuffer(3,rsi2d);
   SetIndexBuffer(4,rsi3u);
   SetIndexBuffer(5,rsi3d);
   
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame1=="returnBars"); if (returnBars) return(0);
      
      //
      //
      //
      //
      //
      
      for (int i=0; i<8; i++) 
      {
         SetIndexStyle(i,DRAW_ARROW,EMPTY,LinesWidth); SetIndexArrow(i,110); 
      }
      timeFrames[0] = stringToTimeFrame(TimeFrame1);
      timeFrames[1] = stringToTimeFrame(TimeFrame2);
      timeFrames[2] = stringToTimeFrame(TimeFrame3);
      
      IndicatorShortName(UniqueID);
   return(0);
}
int deinit()
{
   for (int t=0; t<4; t++) ObjectDelete(UniqueID+t);
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rsi1u[0] = limit+1; return(0); }

         if (timeFrames[0] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[0],indicatorFileName,"returnBars",0,0)*timeFrames[0]/Period()));
         if (timeFrames[1] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[1],indicatorFileName,"returnBars",0,0)*timeFrames[1]/Period()));
         if (timeFrames[2] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[2],indicatorFileName,"returnBars",0,0)*timeFrames[2]/Period()));
         if (timeFrames[3] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[3],indicatorFileName,"returnBars",0,0)*timeFrames[3]/Period()));

         //
         //
         //
         //
         //
         
         bool initialized = false;
         if (!initialized)
         {
            initialized = true;
            int window = WindowFind(UniqueID);
            for (int t=0; t<4; t++)
            {
               string label = timeFrameToString(timeFrames[t]);
               ObjectCreate(UniqueID+t,OBJ_TEXT,window,0,0);
                  ObjectSet(UniqueID+t,OBJPROP_COLOR,LabelsColor);
                  ObjectSet(UniqueID+t,OBJPROP_PRICE1,t+LabelsVerticalShift);
                  ObjectSetText(UniqueID+t,label,7,"Arial");
            }               
         }
         for (t=0; t<4; t++) ObjectSet(UniqueID+t,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

   //
   //
   //
   //
   //
    
   for(int i = limit; i >= 0; i--)
   {
      for (int k=0; k<4; k++)
      {
         int y = iBarShift(NULL,timeFrames[k],Time[i]);
            double rsic = iRSI(NULL,timeFrames[k],RsiPeriod,RsiPrice,y);
            if (ColorsForSlope)
            {
               bool isUp = (rsic>iRSI(NULL,timeFrames[k],RsiPeriod,RsiPrice,y+1));
               switch (k)
               {
                  case 0 : if (isUp) { rsi1u[i] = k+1; rsi1d[i] = EMPTY_VALUE;}  else { rsi1d[i] = k+1; rsi1u[i] = EMPTY_VALUE; } break;
                  case 1 : if (isUp) { rsi2u[i] = k+1; rsi2d[i] = EMPTY_VALUE;}  else { rsi2d[i] = k+1; rsi2u[i] = EMPTY_VALUE; } break;
                  case 2 : if (isUp) { rsi3u[i] = k+1; rsi3d[i] = EMPTY_VALUE;}  else { rsi3d[i] = k+1; rsi3u[i] = EMPTY_VALUE; } break;
                 
               }
            }
            else               
            {
               int state = 0;
                  if (rsic>RsiLevelUp)   state =  1;
                  if (rsic<RsiLevelDown) state = -1;
                  switch (k)
                  {
                     case 0 : rsi1d[i] = EMPTY_VALUE; rsi1u[i] = EMPTY_VALUE; if (state==1) rsi1u[i] = k+1; if (state==-1) rsi1d[i] = k+1; break;
                     case 1 : rsi2d[i] = EMPTY_VALUE; rsi2u[i] = EMPTY_VALUE; if (state==1) rsi2u[i] = k+1; if (state==-1) rsi2d[i] = k+1; break;
                     case 2 : rsi3d[i] = EMPTY_VALUE; rsi3u[i] = EMPTY_VALUE; if (state==1) rsi3u[i] = k+1; if (state==-1) rsi3d[i] = k+1; break;
                     
                  }
            }
      }
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int toInt(double value) { return(value); }
int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   int max = ArraySize(iTfTable)-1, add=0;
   int nxt = (StringFind(tfs,"NEXT1")>-1); if (nxt>0) { tfs = ""+Period(); add=1; }
       nxt = (StringFind(tfs,"NEXT2")>-1); if (nxt>0) { tfs = ""+Period(); add=2; }
       nxt = (StringFind(tfs,"NEXT3")>-1); if (nxt>0) { tfs = ""+Period(); add=3; }

      //
      //
      //
      //
      //
         
      for (int i=max; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[toInt(MathMin(max,i+add))],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}